Subject: Re: [PATCH net-next] net: netdevsim: Support setting dev->perm_addr

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Tue, 04 Feb 2025 11:30:45 +0100

Andrew Lunn <[email-masked]> writes:

> On Mon, Feb 03, 2025 at 02:39:58PM -0800, Jakub Kicinski wrote:
>> On Mon, 03 Feb 2025 18:21:24 +0100 Toke Høiland-Jørgensen wrote:
>> > Network management daemons that match on the device permanent address
>> > currently have no virtual interface types to test against.
>> > NetworkManager, in particular, has carried an out of tree patch to set
>> > the permanent address on netdevsim devices to use in its CI for this
>> > purpose.
>> > 
>> > To support this use case, add a debugfs file for netdevsim to set the
>> > permanent address to an arbitrary value.
>> 
>> netdevsim is not for user space testing. We have gone down the path
>> of supporting random features in it already, and then wasted time trying
>> to maintain them thru various devlink related perturbations, just to
>> find out that the features weren't actually used any more.
>> 
>> NetworkManager can do the HW testing using virtme-ng.
>> 
>> If you want to go down the netdevsim path you must provide a meaningful 
>> in-tree test, but let's be clear that we will 100% delete both the test
>> and the netdevsim functionality if it causes any issues.
>
> Hi Toke
>
> What are your actual requirements? A permanent address is not expected
> to change, it is by definition, permanent. Could it be hard coded in
> netdevsim that the first instance created gets the MAC address
> 24:42:42:42:42:42? And maybe to make testing a bit more evil, keep the
> current behaviour that the actually used MAC is random, since that MAC
> address is not permanent.

I believe that would work, yeah. AFAIU, we just need some virtual device
that has the permanent address field set at all. I'll check with the NM
folks and respin with a static value, assuming this works for them.
Thanks for the suggestion!

-Toke